package ch.epfl.isochrone.timetable;

import java.util.HashSet;
import java.util.Set;

/**
 * Classe servant à stocker des services.
 * 
 * @author Charles Thiebaut (238935)
 * @author Arnaud Delamare (234841)
 * 
 */
public final class Service {

    private final String name;
    private final Date startingDate;
    private final Date endingDate;
    private final Set<Date.DayOfWeek> operatingDays;
    private final Set<Date> excludedDates;
    private final Set<Date> includedDates;

    /**
     * @param name
     *            le nom du service.
     * @param startingDate
     *            debut de la période de service.
     * @param endingDate
     *            fin de la période de service.
     * @param operatingDays
     *            jour où le service fonctionne.
     * @param excludedDates
     *            jour où le service n'est pas distribuer.
     * @param includedDates
     *            jour où le server est exeptionnelement distribué.
     * @throws IllegalArgumentException
     *             si la date de fin est antérieure à la date de début, si une
     *             des dates listées dans les exceptions est en dehors de la
     *             plage de validité du service, ou si l'intersection entre les
     *             dates exclus et incluses n'est pas valide.
     * 
     */
    public Service(String name, Date startingDate, Date endingDate,
            Set<Date.DayOfWeek> operatingDays, Set<Date> excludedDates,
            Set<Date> includedDates) {
        if (startingDate.compareTo(endingDate) == 1) {
            throw new IllegalArgumentException("La date départ est postérieure à la date finale du service");
        }

        for (Date d : excludedDates) {
            if (startingDate.compareTo(d) == 1 || endingDate.compareTo(d) == -1) {
                throw new IllegalArgumentException("Une date exclue n'est pas entre la date de départ et la date de fin");
            }
        }

        for (Date d : includedDates) {
            if (startingDate.compareTo(d) == 1 || endingDate.compareTo(d) == -1) {
                throw new IllegalArgumentException("Une date inclue n'est pas entre la date de départ et la date de fin");
            }
        }

        for (Date d : includedDates) {
            if (excludedDates.contains(d)) {
                throw new IllegalArgumentException("Une date est à la fois exclue et inclue");
            }
        }

        this.name = name;
        this.startingDate = startingDate;
        this.endingDate = endingDate;
        this.operatingDays = new HashSet<Date.DayOfWeek>(operatingDays);
        this.excludedDates = new HashSet<Date>(excludedDates);
        this.includedDates = new HashSet<Date>(includedDates);
    }

    /**
     * @return le nom du service.
     */
    public String name() {
        return this.name;
    }

    /**
     * @param ok
     *            definie si le service est bien operant à la date passé en
     *            argument.
     * @param date
     *            date pour laquelle on veut vérifier si le service est opérant.
     * @return faulse si le service n'est pas distribuer au jour passé en
     *         argument True si le service est distribuer au jour passé en
     *         argument.
     */
    public boolean isOperatingOn(Date date) {
        boolean ok = false;

        if ((startingDate.compareTo(date) == 0 || startingDate.compareTo(date) == -1)
                && (endingDate.compareTo(date) == 0 || endingDate
                        .compareTo(date) == 1)) {
            if (operatingDays.contains(date.dayOfWeek()))
            {
                ok = true;
            }

            if (ok == true) {
                if (excludedDates.contains(date)) {
                    return false;
                }
            } else {
                if (includedDates.contains(date)) {
                    return true;
                }
            }

        }

        return ok;
    }

    /**
     * @return le nom du service.
     */
    public String toString() {
        return name;
    }

    /**
     * class qui sert de builder pour un service.
     */
    public static final class Builder {
        private final String name;
        private final Date startingDate;
        private final Date endingDate;
        private final Set<Date.DayOfWeek> operatingDays;
        private final Set<Date> excludedDates;
        private final Set<Date> includedDates;

        /**
         * @param name
         *            le nom du sevice.
         * @param startingDate
         *            la date du début du service.
         * @param endingDate
         *            la date de fin du service.
         * @throw IllegalArgumentException si la date de début est postérieure à
         *        la date de fin.
         */
        public Builder(String name, Date startingDate, Date endingDate) {
            if (startingDate.compareTo(endingDate) == 1) {
                throw new IllegalArgumentException("La date départ est postérieure à la date finale du service");
            }

            this.name = name;
            this.startingDate = startingDate;
            this.endingDate = endingDate;
            this.operatingDays = new HashSet<Date.DayOfWeek>();
            this.excludedDates = new HashSet<Date>();
            this.includedDates = new HashSet<Date>();
        }

        /**
         * @return le nom du service.
         */
        public String name() {
            return this.name;
        }

        /**
         * methode qui ajoute un jour où le service est distribué
         * 
         * @param day
         *            le jour que l'on souhaite ajouté au date où le service est
         *            distribué.
         * @return le builder modifié.
         */
        public Builder addOperatingDay(Date.DayOfWeek day) {
            operatingDays.add(day);

            return this;
        }

        /**
         * methode qui ajoute un jour où le service n'est pas distribué
         * 
         * @param date
         *            date que l'on souhaite ajouté aux dates excluses.
         * @throw IllegalArgumentException si la date est antérieure a la date
         *        de début du service ou si elle est postérieure à la date de
         *        fin.
         * @return le builder modifié.
         */
        public Builder addExcludedDate(Date date) {
            if (startingDate.compareTo(date) == 1
                    || endingDate.compareTo(date) == -1) // pas dans plage de
                                                         // validite
            {
                throw new IllegalArgumentException("La date n'est pas dans la plage de validité !");
            }
            
            if (includedDates.contains(date))
                throw new IllegalArgumentException("La date est deja dans les exceptions incluses !");
            excludedDates.add(date);

            return this;
        }

        /**
         * methode qui ajoute un jour où le service est (exceptionnelement)
         * distribué
         * 
         * @param date
         *            date que l'on souhaite ajouté aux dates incluses.
         * @throw IllegalArgumentException si la date est antérieure a la date
         *        de début du service ou si elle est postérieure à la date de
         *        fin.
         * @return le builder modifié.
         */
        public Builder addIncludedDate(Date date) {
            if (startingDate.compareTo(date) == 1
                    || endingDate.compareTo(date) == -1) // pas dans plage de
                                                         // validite
            {
                throw new IllegalArgumentException("La date n'est pas dans la plage de validité !");
            }
            
            if (excludedDates.contains(date))
                throw new IllegalArgumentException("La date est deja dans les exceptions excluses !");
            includedDates.add(date);

            return this;
        }

        /**
         * @return le service construit via le builder.
         */
        public Service build() {
            return new Service(name, startingDate, endingDate, operatingDays,
                    excludedDates, includedDates);
        }
    }

}
